﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=2.51
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

	Public mkey(30) As String
	Public mval(30) As String
	Public last As Int = 0

End Sub

'Clears the whole map
public Sub Clear
	For i = 0 To 30
		mkey(i) = ""
		mval(i) = ""
	Next
End Sub

'Checks if such key exists in the map, returns true if exists, false if not.
public Sub ContainsKey (Key As String) As Boolean
	Dim b As Boolean = False
	For i = 0 To mkey.Length - 1
		If mkey(i) = Key Then
			b = True
			Exit
		End If
	Next
	Return b
End Sub

'Puts the key and value pair, updates the value if the key exists already.
public Sub Put(key As String, Value As String)
	For i = 0 To last -1
		If mkey(i) = key Then
			mval(i) = Value
			Return
		End If
	Next
	mkey(last) = key
	mval(last) = Value
	last = last +1
End Sub

'Retrieves the value of the key if the key exists, if not returns -1.
public Sub Get(Key As String) As String
	Dim k As Int
	For i = 0 To mkey.Length - 1
		If mkey(i) = Key Then
			k = i
			Exit
		End If
	Next
	Return mval(k)
End Sub

'Gets the key in the index.
public Sub GetKeyAt (Index As Int) As String
	Return mkey(Index)
End Sub

'Gets the value in the index.
public Sub GetValueAt (Index As Int) As String
	Return mval(Index)
End Sub

'Gets the first index key if exists, else returns -1
public Sub GetByValue(Value As String) As String
	For i = 0 To last - 1
		If mval(i) = Value Then Return mkey(i)
	Next
	Return -1
End Sub

'Returns the key array.
'Example for use:
'For i = 0 To map.last 
'   Log(map.Keys(i))
'next
public Sub Keys As String()
	Return mkey
End Sub

'Returns the values array
'Example for use:
'For i = 0 To map.last 
'   Log(map.Values(i))
'next
public Sub Values As String()
	Return mval
End Sub

'Removes the key-value pair, moves the last pair to the vacant place.
public Sub Remove (Key As String) As String
	Dim k As Int
	For i = 0 To last - 1
		If mkey(i) = Key Then
			k = i
			Exit
		End If
	Next
	Dim temp As String = mval(k)
	mval(k) = ""
	mkey(k) = ""
	
	mkey(k) = mkey(last-1)
	mval(k) = mval(last-1)
	mkey(last-1) = ""
	mval(last-1) = ""
	
	last = last - 1
	
	Return temp
End Sub
